/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define MOD 1000000007

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}
struct point {
    ll a,b,c,d,x;
};

bool per(ll x1, ll y1, ll x2, ll y2, ll xx1, ll yy1, ll xx2, ll yy2) {
    if(x2 >= xx1 && y2 >= yy1)
        return true;
    else return false;
}

point res[400000];

int main() {
    freopen("calculation.in", "r", stdin);
    freopen("calculation.out", "w", stdout);
    //cout << 7/10 << endl;
    ll a, b, c, d, n;
    ll ans1, ans2, ans3, ans4;
    ans1 = ans2 = ans3 = ans4 = 0;
    cin >> a >> b >> c >> d >> n;

    ll k = (5*a + 10*b + 20*c + 50*d);
    //cout << k << endl;

    if((n % 5 != 0) || (k < n) || (n > 85000000)) {
        cout << "-1\n";
        return 0;
    }

    n /= 5;
    //cout << n << ' ' << d << endl;

    if(n >= 20) {
        if(((n - 20) / 10) <= d) {
            ans4 += ((n - 20) / 10);
            n %= 10;
            n += 20;
        } else {
            ans4 += d;
            n -= 10*d;
        }
        d -= ans4;
    }

    if(d) {
        vector<int> arr;
        if(a > 0) arr.push_back(1);
        if(b > 0) arr.push_back(2);
        if(c > 0) arr.push_back(4);
        if(d > 0) arr.push_back(10);


        for(int i = 0; i < arr.size(); i++) {
            res[arr[i]].x = 1;
            if(arr[i] == 1) res[arr[i]].a = 1;
            else if(arr[i] == 2) res[arr[i]].b = 1;
            else if(arr[i] == 4) res[arr[i]].c = 1;
            else if(arr[i] == 10) res[arr[i]].d = 1;

            for(int j = 1; j <= n; j++) {
                if(res[j].x && j+res[i].x <= n && (!res[j + arr[i]].x || res[j].x + 1 < res[j + arr[i]].x)) {
                    if(arr[i] == 1) {
                        if(res[j].a != a) {
                            res[j + arr[i]].x = res[j].x + 1;
                            res[j + arr[i]].a = res[j].a + 1;
                            res[j + arr[i]].b = res[j].b;
                            res[j + arr[i]].c = res[j].c;
                            res[j + arr[i]].d = res[j].d;
                        }
                    } else if(arr[i] == 2) {
                        if(res[j].b != b) {
                            res[j + arr[i]].x = res[j].x + 1;
                            res[j + arr[i]].a = res[j].a;
                            res[j + arr[i]].b = res[j].b + 1;
                            res[j + arr[i]].c = res[j].c;
                            res[j + arr[i]].d = res[j].d;
                        }
                    }
                    else if(arr[i] == 4) {
                        if(res[j].c != c) {
                            res[j + arr[i]].x = res[j].x + 1;
                            res[j + arr[i]].a = res[j].a;
                            res[j + arr[i]].b = res[j].b;
                            res[j + arr[i]].c = res[j].c + 1;
                            res[j + arr[i]].d = res[j].d;
                        }
                    }
                    else if(arr[i] == 10) {
                        if(res[j].d != d) {
                            res[j + arr[i]].x = res[j].x + 1;
                            res[j + arr[i]].a = res[j].a;
                            res[j + arr[i]].b = res[j].b;
                            res[j + arr[i]].c = res[j].c;
                            res[j + arr[i]].d = res[j].d + 1;
                        }
                    }
                }
            }
        }
        if(!res[n].x) cout << "-1\n"; else
        cout << res[n].a << ' ' << res[n].b << ' ' << res[n].c << ' ' << res[n].d + ans4 << ' ' << res[n].a + res[n].b + res[n].c + res[n].d + ans4 << endl;

        /*while(res[n].x > 1) {
            for(int i = 0; i < n; i++) {
                if(res[n - arr[i]] == res[n - 1]) {
                    //cout << arr[i] << ' ';
                    if(arr[i] == 1) ans1++;
                    else if(arr[i] == 2) ans2++;
                    else if(arr[i] == 4) ans3++;
                    else if(arr[i] == 10) ans4++;
                    n -= arr[i];
                    break;
                }
            }
        }
        if(n == 1) ans1++;
        else if(n == 2) ans2++;
        else if(n == 4) ans3++;
        else if(n == 10) ans4++;*/

        //cout << res[n] + ans1 + ans2 + ans3 + ans4;

    }else {

    if((n / 4) <= c) {
        ans3 += (n / 4);
        n %= 4;
    } else {
        ans3 += c;
        n -= 4*c;
    }
//cout << n << endl;
    if((n / 2) <= b) {
        ans2 += (n / 2);
        n %= 2;
    } else {
        ans2 += b;
        n -= 2*b;
    }
//cout << n << endl;
    if(n <= a) {
        ans1 += n;
    } else {
        cout << "-1\n";
        return 0;
    }
    cout << ans1 << ' ' << ans2 << ' ' << ans3 << ' ' << ans4 << ' ' << ans1 + ans2 + ans3 + ans4 << endl;
    }

    /*while(d > 0 && ((ans2 - 1) >= 0) && ((ans3 - 2) >= 0)) {
        ans2--;
        ans3 -= 2;
        d--;
        ans4++;
    }

    while(d > 0 && (ans2/5) > 0) {
        ans2/=5;
        d--;
        ans4++;
    }*/

}


/*

0 1000000 1000000 1000000 1000050



1000000 1000000 1000000 1000000 100000000

3 4
4
1 1 1 2
1 1 3 3
2 2 3 3
2 3 3 4
*/

