/* GCC */
#include <fstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

int main()
{
    const int milliard = 1000000000;
    ifstream in;
    ofstream out;
    in.open("calculation.in");
    out.open("calculation.out");
    int n5, n10, n20, n50;
    in >> n5 >> n10 >> n20 >> n50;
    int sum;
    in >> sum;

    int steps = sum/5 +1;
    if (sum % 5 != 0) {
        out << "-1" << endl;
        return 0;
    }
    int dp[steps][5]; //dp[i][0] = total coins, dp[i][j] = if exact type
    for (int i = 0; i < 5; i++) {
        dp[0][i] = 0;
    }

    for (int i = 1; i < steps; i++) {
        int try50 = milliard,
        try20 = milliard,
        try10 = milliard,
        try5 = milliard;
        if (i >= 10 && dp[i-10][1] < n50) {
            try50 = dp[i-10][0] + 1;
        }
        else if (i >= 4 && dp[i-4][2] < n20) {
            try20 = dp[i-4][0] + 1;
        }
        else if (i >= 2 && dp[i-2][3] < n10) {
            try10 = dp[i-2][0] + 1;
        }
        else if (dp[i-1][4] < n5) {
            try5 = dp[i-1][0] + 1;
        } else {
            dp[i][0] = milliard;
            continue;
        }
        int minn = min(min(min(try50, try20), try10), try5);
        dp[i][0] = minn;
        if (minn == try50) {
            dp[i][1] = dp[i-10][1] + 1;
            dp[i][2] = dp[i-10][2];
            dp[i][3] = dp[i-10][3];
            dp[i][4] = dp[i-10][4];
        }
        else if (minn == try20) {
            dp[i][1] = dp[i-4][1];
            dp[i][2] = dp[i-4][2] + 1;
            dp[i][3] = dp[i-4][3];
            dp[i][4] = dp[i-4][4];
        }
        else if (minn == try10) {
            dp[i][1] = dp[i-2][1];
            dp[i][2] = dp[i-2][2];
            dp[i][3] = dp[i-2][3] + 1;
            dp[i][4] = dp[i-2][4];
        }
        else{
            dp[i][1] = dp[i-1][1];
            dp[i][2] = dp[i-1][2];
            dp[i][3] = dp[i-1][3];
            dp[i][4] = dp[i-1][4] + 1;
        }
    }

    if (dp[steps-1][0] == milliard) {
        out << "-1" << endl;
    } else {
        out << dp[steps-1][4] << " "
            << dp[steps-1][3] << " "
            << dp[steps-1][2] << " "
            << dp[steps-1][1] << " "
            << dp[steps-1][0] << endl;
    }

    in.close();
    out.close();
    return 0;
}
