/* GCC */
#include <fstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

int main()
{
    ifstream in;
    ofstream out;
    in.open("strings.in");
    out.open("string.out");
    int len;
    in >> len;
    string S;
    in >> S;
    int max_res[len];
    max_res[0] = 0;
    for (int i = 1; i < len; i++) {
        int cur_max = 0;
        for (int j = 0; j < i; j++) {
            int cur = abs(S[i]-S[j]) * (i-j) + max_res[j];
            if (cur > cur_max) cur_max = cur;
        }
        max_res[i] = cur_max;
    }
    out << max_res[len-1] << endl;
    in.close();
    out.close();
    return 0;
}
