#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdio>

using namespace std;

const int Nmax = 1e6+2;
int N;
char str[Nmax];
long long maxp[Nmax];

void fill_maxp()
{
    maxp[N] = 0;
    long long cost;
    for (int k = N-1; k >= 1; --k){
        for (int i = k+1; i <= N; ++i){
            cost = abs(int(str[i]-str[k])) * (i-k);
            if (cost + maxp[i] > maxp[k]){
                maxp[k] = cost + maxp[i];
            }
        }
    }
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(); /// prost_komment
    freopen("strings.in", "r", stdin);
    freopen("strings.out", "w", stdout);
    cin >> N;
    for (int i = 1; i <= N; ++i){
        cin >> str[i];
    }
    fill(maxp, maxp+N+1,-1);

    fill_maxp();

    cout << maxp[1];

    return 0;
}
