/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define MOD 1000000007

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}
struct point {
ll x1, y1, x2, y2;
};

bool per(ll x1, ll y1, ll x2, ll y2, ll xx1, ll yy1, ll xx2, ll yy2) {
    if(x2 >= xx1 && y2 >= yy1)
        return true;
    else return false;
}


int main() {
    freopen("strings.in", "r", stdin);
    freopen("strings.out", "w", stdout);


    ll n;
    cin >> n;
    ll s[n];
    char c;
    for(int i = 0; i < n; i++) {
        cin >> c;
        s[i] = (c - 'a');
    }

    ll maxx[n + 1], minn[n + 1], maxxx = -1, minnn = 50, maxi, mini;

    for(int i = n - 1; i >= 0; i--) {
            if(maxxx <= s[i]){
                maxi = i;
                maxxx = s[i];
            }
            if(minnn >= s[i]) {
                mini = i;
                minnn = s[i];
            }

        maxx[i] = maxi;
        minn[i] = mini;
    }

    int i = 0;
    ll ans = 0;
    while(i != (n - 1)) {
            //cout << i << endl;
        maxi = maxx[i];
        mini = minn[i];

        if(abs((i - maxi) * (s[i] - s[maxi])) > abs((i - mini) * (s[i] - s[mini]))) {
            ans += abs((i - maxi) * (s[i] - s[maxi]));
            i = maxi;
        } else {
            ans += abs((i - mini) * (s[i] - s[mini]));
            i = mini;
        }
    }
    cout << ans << endl;
}


/*

0 1000000 1000000 1000000 1000050



1000000 1000000 1000000 1000000 100000000

3 4
4
1 1 1 2
1 1 3 3
2 2 3 3
2 3 3 4
*/


