/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
int n, k;
vector<int> nums;
vector<vector<int> > f;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void show(vector< vector<int> > a){
    for(int i=0; i<a.size(); i++){
        show(a[i]);
    }
    cout<<endl;
}

int getNum(int a){
    if( (a/n)%2==0 ) { //from left
        return nums[a%n];
    } else {
        return nums[n-1-a%n];
    }
}

void readData(){
    freopen("robot.in", "r", stdin);

    scanf("%d %d", &n, &k);
    nums=vector<int>(n);
    f=vector<vector<int> > (2, vector<int>(n+1));
    for(int i=0; i<n; i++) scanf("%d", &nums[i]);

    fclose(stdin);
}

void fileOut(){
    freopen("robot.out", "w", stdout);

    int CURR=1, PREV=0;
    for(int i=0; i<=n; i++){
        if(nums[0]<=i) f[0][i]=1;
        else f[0][i]=0;
    }

    for(int i=1; i<n*k; i++){
        f[CURR][0]=0;
        int curr=getNum(i);
        for(int z=0; z<curr; z++){
            f[CURR][z]=f[PREV][z];
        }
        for(int z=curr; z<=n; z++){
            f[CURR][z]=max(f[PREV][curr-1]+1, f[PREV][z]);
        }
        swap(CURR, PREV);
        //CURR++; PREV++;
    }
    cout<<f[PREV][n]<<endl;

    fclose(stdin);
}

int main(){
    readData();
    fileOut();
    return 0;
}
