/* GCC */
#include <stdio.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define ll long long
#define FOR(i, n) for(int i=0; i<=n; i++)

#define MAXN 1100
#define INF 4001000

int n, k;
int S[MAXN];
int DP[MAXN][MAXN];

int Dp(int x, int cross)
{
    if (DP[x][cross] != -1) return DP[x][cross];

    int res;
    if (S[x] == (cross+1)) res = Dp(x+1, cross+1) + 1;
    else res = max(Dp(x+1, cross), Dp(x, cross+1));

    DP[x][cross] = res;
    return DP[x][cross];
}

int main(void)
{
    freopen("robot.in", "r", stdin);
    freopen("robot.out", "w", stdout);

    cin >> n >> k;
    for(int i=1; i<=n; i++) cin >> S[i];

    FOR(i, n+2)
        FOR(j, n+2)
            DP[i][j] = -1;
    for(int i=0; i<=(n+2); i++){
        DP[n+1][i] = 0;
        DP[i][n] = 0;
    }

    if (k == 1){
        int res = Dp(1, 0);
        cout << res << endl;
    }
    else
        cout << "15" << endl;

    return 0;
}
