/* GCC */

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define FilkinMaksim int main()
#define ALL(a) a.begin(),a.end()
#define f_in(s) freopen(s,"r",stdin)
#define f_out(s) freopen(s,"w",stdout)
#define endl '\n'
#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define X first
#define Y second

const int inf = 1e9;
const long long linf = 1e12;
const long long mod = 1e9 + 7;

typedef long long ll;
typedef long double ld;

string s;
map <int,set<int> > r;

/*int ans(int n)
{
    int res = 0;
    for (int i = 0; i < n; i++)
    {
        int j = i;
        while (j < n && s[j] == '1') j++;
        j --;
        for (int k = i; k <= j; k++)
            if (r[k] < j)
                r[k] = j;
    }
    for (int i = 0; i < n; i++)
        cout << r[i] << ' ';
    cout << endl;
    cout << s << endl;
    for (int i = 0; i < n; i++)
        if (r[i] >= i) res += (r[i] - i + 1) * (r[i] - i + 2) / 2, i = r[i];
    return res;
}*/


int ans(int n)
{
    int res = 0;
    for (int i = 0; i < n; i++)
    {
        int j = i;
        while (j < n && s[j] == '1') j++;
        for (int k = i; k <= j; k++)
            for (int q = k + 1; q <= j; q++)
                r[k].insert(q);
    }
    for (int i = 0; i < n; i++)
        res += r[i].size();
    return res;
}

FilkinMaksim
{
    f_in("lanterns.in");
    f_out("lanterns.out");
    int q,n;
    cin >> n >> q;
    cin >> s;
    cout << ans(n) << endl;
    while (q--)
    {
        int x,y,t;
        char z;
        cin >> x >> y >> t;
        if (t) z = '1';
        else z = '0';
        x--;y--;
        for (int i = x; i <= y; i++)
            s[i] = z;
        cout << ans(n) << endl;
    }
}
