#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

vector <bool> dead_lat(10001);
int start_lan[300002];
int N, Q;

long long count_good_zones()
{
    int prev = 0;
    long long res = 0;
    for (int i = 1; i <= N; ++i){
        if (dead_lat[i] == true){
            res += (i-prev)*(i-prev-1)/2;
            prev = i;
        }
    }
    res += (N-prev)*(N-prev+1)/2;

    return res;
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio();
    freopen("lanterns.in", "r", stdin);
    freopen("lanterns.out", "w", stdout);

    cin >> N >> Q;
    char c;
    fill(dead_lat.begin(), dead_lat.end(), 0);
    dead_lat[0] = true;

    for (int i = 1; i <= N; ++i){
        cin >> c;
        if (c == '1'){
            start_lan[i] = 1;
        }
        if (c == '0'){
            start_lan[i] = 0;
            dead_lat[i] = true;
        }
    }

    cout << count_good_zones();



    int L, R, C;
    while (Q > 0){
        --Q;
        cin >> L >> R >> C;
        for (int i = 1; i <= N; ++i){
            if ( (dead_lat[i] == true) && (L <= i) && (i <= R) && (C == 1) ){ /// dead lamp number i became alive
                dead_lat[i] = false;
            }
        }

        cout << "\n" << count_good_zones();
    }
    return 0;
}
