/* GCC */
#include <bits/stdc++.h>

using namespace std;

bool arr[300001] = {0}, matrix[5001][5001] = {0};

long long segm(bool arr[], int l){
    long long sum = 0;
    int counter = 0;
    for(int i = 1; i <= l; i++){
        if(arr[i] == true){
            counter++;
        }
        else{
            sum += counter * (counter + 1) / 2;
            counter = 0;
        }
    }
    sum += counter * (counter + 1) / 2;
    return sum;
}

void build_matrix(bool arr[], int l, bool matr[5001][5001]){
    for(int i = 1; i <= l; i++){
        for(int j = i; j <= l && arr[j] != 0; j++)
            matr[i][j] = true;
    }
}

long long get(bool matr[5001][5001], int l){
    long long counter = 0;
    for(int i = 1; i <= l; i++)
        for(int j = 1; j <= l; j++)
            if(matr[i][j] == 1)
                counter++;
    return counter;
}

int main()
{
    freopen("lanterns.in", "r", stdin);
    freopen("lanterns.out", "w", stdout);

    int l, n, st, fin, done;
    long long maxim = 0;

    cin >> l >> n;

    string s;
    cin >> s;
    for(int i = 1; i <= l; i++){
        if(s[i - 1] == '1')
            arr[i] = true;
        else
            arr[i] = false;
    }


    build_matrix(arr, l, matrix);
    cout << get(matrix, l) << endl;

    for(int i = 0; i < n; i++){
        cin >> st >> fin >> done;
        for(int j = st; j <= fin; j++)
            arr[j] = done;
        if(done == 1)
            build_matrix(arr, l, matrix);
        cout << get(matrix, l) << endl;
    }

    return 0;
}
