import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;

public class dog {

	private static int firstDogAggressive, firstDogCalm, secondDogAggressive, secondDogCalm;
	
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("dog.in"));
		BufferedWriter out = new BufferedWriter(new FileWriter("dog.out"));
		
		StringTokenizer tok = new StringTokenizer(in.readLine());
		firstDogAggressive = Integer.parseInt(tok.nextToken());
		if (!tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		firstDogCalm = Integer.parseInt(tok.nextToken());
		if (!tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		secondDogAggressive = Integer.parseInt(tok.nextToken());
		if (!tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		secondDogCalm = Integer.parseInt(tok.nextToken());
		
		if (!tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		String a = tok.nextToken();
		if (!tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		String b = tok.nextToken();
		if (!tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		String c = tok.nextToken();
		out.write(
				Integer.toString(checkDogAttack(Integer.parseInt(a))) + "\n" +
				Integer.toString(checkDogAttack(Integer.parseInt(b))) + "\n" +
				Integer.toString(checkDogAttack(Integer.parseInt(c))) + "\n"
		);
		
		out.flush();
	}
	
	private static int checkDogAttack(int time) {
		int result = 0;
		if (firstDogAggressive + firstDogCalm != 0) {
			int a = time % (firstDogAggressive + firstDogCalm);
			if (a <= firstDogAggressive && a != 0) {
				result = 1;
			}
		}
		if (secondDogAggressive + secondDogCalm != 0) {
			int b = time % (secondDogAggressive + secondDogCalm);
			if (b <= secondDogAggressive && b != 0) {
				result++;
			}
		}
		return result;
	}
	
}
