/* GCC */
#include <fstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <algorithm>
using namespace std;

int main()
{
    ifstream in;
    ofstream out;
    in.open("calculation.in");
    out.open("calculation.out");
    int n5, n10, n20, n50;
    in >> n5 >> n10 >> n20 >> n50;
    int sum;
    in >> sum;
    int payment = sum;

    int cur_sum = 0;
    int take50 = 0, take20 = 0, take10 = 0, take5 = 0;
    bool try_variant = false;

    if (50 * n50 <= payment) {
        take50 = n50;
    } else {
        take50 = payment / 50;
    }
    cur_sum += 50 * take50;
    payment -= 50 * take50;

    //Variant
    if (take50 != 0) {
        try_variant = true;
    }

    if (20 * n20 <= payment) {
        take20 = n20;
    } else {
        take20 = payment / 20;
    }
    cur_sum += 20 * take20;
    payment -= 20 * take20;

    if (10 * n10 <= payment) {
        take10 = n10;
    } else {
        take10 = payment / 10;
    }
    cur_sum += 10 * take10;
    payment -= 10 * take10;

    if (5 * n5 <= payment) {
        take5 = n5;
    } else {
        take5 = payment / 5;
    }
    cur_sum += 5 * take5;
    payment -= 5 * take5;

    int take50v = take50-1, take20v = 0, take10v = 0, take5v = 0;
    int cur_sumv = take50v*50, paymentv = sum-cur_sumv;

    if (try_variant) {
    if (20 * n20 <= paymentv) {
        take20v = n20;
    } else {
        take20v = paymentv / 20;
    }
    cur_sumv += 20 * take20v;
    paymentv -= 20 * take20v;

    if (10 * n10 <= paymentv) {
        take10v = n10;
    } else {
        take10v = paymentv / 10;
    }
    cur_sumv += 10 * take10v;
    paymentv -= 10 * take10v;

    if (5 * n5 <= paymentv) {
        take5v = n5;
    } else {
        take5 = paymentv / 5;
    }
    cur_sumv += 5 * take5v;
    paymentv -= 5 * take5v;
    }

    if (cur_sum != sum && cur_sumv != sum) {
        out << "-1" << endl;
    } else {
        int monets = take50+take20+take10+take5;
        int monetsv = take50v+take20v+take10v+take5v;
        if ((monets <= monetsv && cur_sum == sum) || cur_sumv != sum) {
        out << take5  << " " <<
               take10 << " " <<
               take20 << " " <<
               take50 << " " <<
               monets << endl;
        } else {
        out << take5v  << " " <<
               take10v << " " <<
               take20v << " " <<
               take50v << " " <<
               monetsv << endl;
        }
    }

    in.close();
    out.close();
    return 0;
}
