/* GCC */
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <cstdlib>
#include <fstream>

using namespace std;

int main()
{
    ifstream fin("calculation.in");
    ofstream fout("calculation.out");

    int needsum;
    int sum = 0;
    vector <int> quan(4);
    vector <int> needed(4);

    for(int i = 0; i<4; i++){
        fin >> quan[i];
    }
    fin >> needsum;

    if(needsum % 5 != 0) {
        fout << -1;
        return 0;
    }
    if(needsum == 0){
        fout << "0 0 0 0 0";
    }

    while(quan[3] > 0 && sum+50 <= needsum){
        quan[3]--;
        needed[3]++;
        sum+=50;
    }
    while(quan[2] > 0 && sum+20 <= needsum){
        quan[2]--;
        needed[2]++;
        sum+=20;
    }
    while(quan[1] > 0 && sum+10 <= needsum){
        quan[1]--;
        needed[1]++;
        sum+=10;
    }
    while(quan[0] > 0 && sum+5 <= needsum){
        quan[0]--;
        needed[0]++;
        sum+=5;
    }

    if(sum != needsum) fout << -1;
    else{
        int total = needed[0] + needed[1] + needed[2] + needed[3];
        for(int i = 0; i<4; i++){
            fout << needed[i] << ' ';
        }
        fout << total << endl;
    }



    return 0;
}
