/* GCC */
#include <bits/stdc++.h>

using namespace std;

#define ft first
#define sd second
#define pii pair<int, int>

typedef long long ll;

#define open(s) freopen(s".in", "r", stdin); freopen(s".out", "w", stdout);

int m5, m10, m20, m50, total;

int main(){
    open("calculation");

    cin >> m5 >> m10 >> m20 >> m50 >> total;

    if (m5 * 5 + m10 * 10 + m20 * 20 + m5 * 50 < total || (total % 5) != 0)
    {
        cout << -1 << "\n";
        return 0;
    }

    ll dp[100000000] = {0};
    dp[5] = 1;
    dp[10] = 1;
    dp[20] = 1;
    dp[50] = 1;

    for (int i = 15; i <= total; i+=5)
    {
        if(dp[i] == 0)
        {
            if ((i - 5) / 5 < m5)
                dp[i] = dp[i - 5] ;
            if ((i - 10) / 10 < m10)
            {
                if (dp[i] == 0)
                    dp[i] = dp[i - 10];
                else
                    dp[i] = min(dp[i], dp[i - 10]);
            }
            if (i > 20 && (i - 20) / 20 < m20)
            {
                if (dp[i] == 0)
                    dp[i] = dp[i - 20];
                else
                    dp[i] = min(dp[i], dp[i - 20]);
            }
            if (i > 50 && (i - 50) / 50 < m50)
            {
                if (dp[i] == 0)
                    dp[i] = dp[i - 50];
                else
                    dp[i] = min(dp[i], dp[i - 50]);
            }

            ++dp[i];
        }

        cerr << i << " " << dp[i] << "\n";
    }

    return 0;
}

