/* GCC */
#include <iostream>
#include <vector>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <algorithm>
#include <cmath>

using namespace std;

int sum;

int fit(int coin, int goal, int quant, int mod){
    int counter = 0;
    while((goal-sum) % mod){
        if(quant){
            quant--;
            sum+=coin;
            counter ++;
        } else return -1;
    }
    return counter;

}

int main()
{
    freopen("calculation.in","r",stdin);
    freopen("calculation.out","w",stdout);
    long int  nic, dim, twe, fif, goal;
    cin>>nic>>dim>>twe>>fif;
    cin>>goal;
    sum=0;
    int a,b,c,d;
    a = fit(5, goal, nic, 10);
    b = fit(10, goal, dim, 20);
    c = fit(20, goal, twe, 50);
    if(a == -1 || b == -1 || c == -1){
        cout<<-1;
        return 0;
    }
    d = 0;
    sum = a*5 + b*10 + c*20;
    if(sum < goal  ) d = (goal - sum) / 50;
    if(d > fif){
        cout<<-1;
        return 0;
    }
    cout<<a<<" "<<b<<" "<<c<<" "<<d <<" "<<a+b+c+d ;

    return 0;
}
