#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <string>

using namespace std;

int n;
string s;


int abs(int i){
    if( i >= 0)
        return i;
    return -1*i;
}

int positively(int x){
    if( x> 0)
        return 1;
    if( x < 0)
        return -1;
    return 0;
}

int next_point(int i){
    int j = i;
    while( (j < n-1) && (s[j] == s[i]) ){
        j++;
    }
    if ( (j == n-1) && (s[j] == s[i]) )
        return -1;
    int biggest = abs(s[j] - s[i]), index = j;
    for( int k = 0; (k < n) && (positively(s[j]-s[i]) == positively(s[k] - s[i]) ); k++){
        if( abs(s[k] - s[i]) >= biggest){
            biggest = abs(s[k] - s[i]);
            index = k;
        }
    }
    return index;
}

int count_this_step(int i) {
     int  j = next_point(i);
     if( j == -1)
        return 0;
     return abs(s[j] - s[i])*(j-i);
}

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    freopen("strings.in", "r", stdin);
    freopen("strings.out", "w", stdout);
    cin >> n >> s;
    long long res = 0;
    for( int i = 0; i < n-1; i+=0){
        res += count_this_step(i);
        i = next_point(i);
        if( i == -1)
            i = n;
    }
    cout << res;
    return 0;
}
