/* GCC */
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <math.h>

using namespace std;

int FindNext(string s, int i){
    int symb = s[i];
    int index = i;
    if(i + 1 == s.size() - 1){
        return i + 1;
    }
    for(int j = i + 1;j < s.size();j++){
        if(fabs(s[j] - symb) >= fabs(s[index] - symb)){
            index = j;
        }
    }
    return index;
}

int main(){
    ifstream in;
    in.open("strings.in");
    string s;
    int n;
    in >> n >> s;
    int k = 0;
    for(int i = 0;i < s.size();){
        int l = FindNext(s, i);
        k += (l - i) * fabs(s[i] - s[l]);
        i = l;
        if(i == s.size() - 1){
            break;
        }
    }
    ofstream out;
    out.open("strings.out");
    out << k << endl;
    out.close();
    return 0;
}
