/* GCC */

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

/*     )     ?       ?*/

using namespace std;

#define FilkinMaksim int main()
#define ALL(a) a.begin(),a.end()
#define f_in(s) freopen(s,"r",stdin)
#define f_out(s) freopen(s,"w",stdout)
#define endl '\n'
#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define X first
#define Y second

const int inf = 1e9;
const long long linf = 1e12;
const long long mod = 1e9 + 7;

typedef long long ll;
typedef long double ld;

int dist[30][30];

FilkinMaksim
{
    f_in("strings.in");
    f_out("strings.out");
    int n;
    cin >> n;
    string s;
    cin >> s;
    vector <int> dp;
    dp.assign(n,0);
    for (int i = 0; i < 30; i++)
        for (int j = 0; j < 30; j++)
            dist[i][j] = -1;
    for (int i = 0; i < 30; i++)
        dist[i][s[0]-'a'] = 0;
    for (int i = 1; i < n; i++)
    {
        int x = int(s[i] - 'a');
        for (int j = 0; j < 30; j++)
        {
            if (dist[x][j] == -1) continue;
            dp[i] = max(dp[i],dp[dist[x][j]] + (i - dist[x][j]) * abs(int(s[i]) - 'a' - j));
        }
        for (int j = 0; j < 30; j++)
        {
            if (dist[j][x] == -1) dist[j][x] = i;
            else
            {
                int k = dist[j][x];
                if (dp[i] - dp[k] > abs(j - x) * (i - k)) dist[j][x] = i;
            }
        }
    }
    cout << dp[n - 1] << endl;
}

