/* GCC */

#include <fstream>

using namespace std;

int segments(bool *lanters, int large)
{
    if (large == 0)
    {
        return 0;
    }
    int firstZero = 0;
    while (lanters[firstZero] && firstZero < large)
    {
        firstZero++;
    }
    if (firstZero == large)
    {
        return (large * (large + 1) / 2);
    }
    else
    {
        return segments (lanters, firstZero) + segments (lanters + firstZero + 1, large - firstZero - 1);
    }
}

int main()
{
    ifstream in("lanterns.in");
    ofstream out("lanterns.out");
    int eventNum, lantersNum;
    in >> lantersNum >> eventNum;
    bool *lanters = new bool[lantersNum];
    char lanter [lantersNum];
    in >> lanter;
    for (int i = 0; i < lantersNum; i++)
    {
        if (lanter[i] == '0')
        {
            lanters[i] = 0;
        }
        else
        {
            lanters[i] = 1;
        }
    }
    int first, last, event, raport;
    raport = segments(lanters, lantersNum);
    out << raport << endl;
    for (int i = 0; i < eventNum; i++)
    {
        in >> first >> last >> event;
        if (event)
        {
            for (int f = first; f <= last; f++)
            {
                lanters[f-1] = 1;
            }
            raport = segments(lanters, lantersNum);
        }
        out << raport << endl;
    }
    return 0;
}
