/* GCC */
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <math.h>
#include <string>
#include <cstdlib>
#include <fstream>

using namespace std;

int main()
{
    ifstream fin("lanterns.in");
    ofstream fout("lanterns.out");

    int N, Q;
    fin >> N >> Q;
    string A;
    char b = fin.get();
    char a = fin.get();
    while(a != '\n' || a != ' '){
        A.push_back(a);
        a = fin.get();
    }

    unsigned long long sectors = 0;
    bool inword = false;
    int dl = 0;

    for(int i = 0; i<A.size();i++){
        if(A[i] == '1') {
            inword = true;
            dl++;
        }
        if(A[i] == '0'){
            inword = false;
            sectors+= dl*(dl+1)/2;
            dl = 0;
        }
    }

    dl = 0;

    for(int i = 0; i<Q;i++){
        int L,R,C;
        fin >> L >> R >> C;
        if(C==0) fout << sectors << endl;
        else {
            for(int i = L-1; i<R; i++){
                if(A[i] == '0') A[i] = '1';
            }
            sectors = 0;
            for(int i = 0; i<A.size();i++){
                if(A[i] == '1') {
                    inword = true;
                    dl++;
                }
                if(A[i] == '0'){
                    inword = false;
                    sectors+= dl*(dl+1)/2;
                    dl = 0;
                }
            }
            fout << sectors << endl;
        }
    }

    return 0;
}
