/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include <set>
#include <cstdio>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define MOD 1000000007
#define MAXN 100000

bool prime(ll n) {
    for(ll i = 2; i * i <= n; i++) {
        if(n % i == 0) {
            return false;
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while(a > 1 && b > 1) {
        if(a > b) {
            swap(a, b);
        }
        b = b % a;
    }
    return max(a, b);
}
struct point {
ll x1, y1, x2, y2;
};

bool per(ll x1, ll y1, ll x2, ll y2, ll xx1, ll yy1, ll xx2, ll yy2) {
    if(x2 >= xx1 && y2 >= yy1)
        return true;
    else return false;
}


int main() {
    freopen("lanterns.in", "r", stdin);
    freopen("lanterns.out", "w", stdout);
    //cout << 7/10 << endl;


    ll n, k;
    cin >> n >> k;
    char c;
    bool a[n + 1];
    bool mas[n + 1][n + 1];
    for(int i = 0; i <= n; i++)
        for(int j = 0; j <= n; j++)
            mas[i][j] = false;

    a[n] = false;

    for(int i = 0; i < n; i++) {
        cin >> c;
        if(c == '0') a[i] = false;
        else a[i] = true;
    }

    ll ans = 0, cur = 0, ans1 = 0;
    for(int i = 0; i <= n; i++) {
        if(a[i] == true) cur++;
        else {
                //cout << i - cur << ' ' << cur << endl;
            for(int i1 = i - cur; i1 < i; i1++) {
                for(int j1 = i - cur; j1 < i; j1++) {
                    if(!mas[i1][j1]) {
                        mas[i1][j1] = mas[j1][i1] = true;
                        ans++;
                    }
                }
            }
            cur = 0;
        }
    }
    cout << ans << endl;

    ll l, r, x;
    while(k--) {
        cin >> l >> r >> x;
        //cout << l << r << x << endl;
        l--, r--;
        cur = ans1 = 0;
        if(x == 1) {
            for(l; l <= r; l++)
                a[l] = true;

            for(int i = 0; i <= n; i++) {
                if(a[i] == true) cur++;
                else {
                    for(int i1 = i - cur; i1 < i; i1++) {
                for(int j1 = i - cur; j1 < i; j1++) {
                    if(!mas[i1][j1]) {
                        mas[i1][j1] = mas[j1][i1] = true;
                        ans++;
                    }
                }
            }
            cur = 0;
                }
            }
            //ans = max(ans, ans1);
            cout << ans << endl;
        } else {
            for(l; l <= r; l++)
                a[l] = false;

            for(int i = 0; i <= n; i++) {
                if(a[i] == true) cur++;
                else {
                    for(int i1 = i - cur; i1 < i; i1++) {
                for(int j1 = i - cur; j1 < i; j1++) {
                    if(!mas[i1][j1]) {
                        mas[i1][j1] = mas[j1][i1] = true;
                        ans++;
                    }
                }
            }
            cur = 0;
                }
            }
            //ans = max(ans, ans1);
            cout << ans << endl;
        }
        //cout << ans1 << endl;
    }
}


/*

0 1000000 1000000 1000000 1000050



1000000 1000000 1000000 1000000 100000000

3 4
4
1 1 1 2
1 1 3 3
2 2 3 3
2 3 3 4
*/


