/* GCC */

#include <iostream>
#include <algorithm>
#include <stdio.h>

using namespace std;


char a[300007];
bool c[46309][46309] = {false};

int segments_before(int start, int i){
    int number = 0;
    for( int j = start; j <= i; j++){
        if( c[j][i] == false){
        number++;
        c[j][i] = true;
        }
    }
    return number;
}

void crash(int start, int finish){
    for(int i = start; i <= finish; i++)
        a[i] = '0';
}

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    freopen("lanterns.in", "r", stdin);
    freopen("lanterns.out", "w", stdout);
    int n, q, p = 0, number = 0;
    cin >> n >> q;
    for(int i = 0; i < n; i++){
        cin >> a[i];
        if( a[i] == '1'){
          number += segments_before(i-p, i);
          p++;
        }
        else
          p = 0;
    }
    a[n] = '1';
    cout << number << '\n';
    int start, finish;
    char x;
    for( int i = 0; i < q; i++){
        cin >> start >> finish >> x;
        start --;
        finish--;
        if( x == '0' ){
            crash(start, finish);
        }
        else{
            for(int i = start-1; (i >= 0) && (a[i] == '1'); i--)
                start--;
            for(int i = finish+1; (i < n) && (a[i] == '1'); i++)
                finish++;
       //         cout << start << " " << finish;
            for(int i = start; i <= finish; i++){
                a[i] = '1';
                number += segments_before(start, i);
            }
        }
        cout << number << '\n';
    }
    return 0;
}
