/* GCC */

#include<fstream>
#include<vector>

using namespace std;

int n, q;

int main(){
    ifstream in;
    in.open("lanterns.in");
    ofstream out;
    out.open("lanterns.out");

    in >> n >> q;
    vector<bool> pos(n);
    vector< vector<bool> > arr(n, vector<bool>(n));
    for(int i = 0; i < n; i++){
        char c;
        in >> c;
        if(c == '1') pos[i] = true;
    }
    int sum = 0;
    for(int counter = 0; counter <= q; counter++){
        if(counter > 0){
            int l, r;
            bool c;
            in >> l >> r >> c;
            for(int i = l-1; i < r; i++){
                pos[i] = c;
            }
        }
        int last = 0;
        bool prev1 = false;
        for(int i = 0; i < n; i++){
            if(pos[i]){
                if(!prev1){
                    prev1 = true;
                    last = i;
                }
                for(int j = last; j <= i; j++){
                    if(!arr[j][i]){
                        arr[j][i] = true;
                        sum++;
                    }
                }
            }
            else{
                prev1 = false;
            }
        }
        out << sum << endl;
    }

    out.close();
    in.close();
}
